## EX3700_EX3800-V1.0.0.100_1.0.64_src.zip

=== Makefile ===
###########################################################################
#
# Makefile -- Top level uClinux makefile.
#
# Copyright (c) 2001-2004, SnapGear (www.snapgear.com)
# Copyright (c) 2001, Lineo
#

VERSIONPKG = 3.2.0
VERSIONSTR = $(CONFIG_VENDOR)/$(CONFIG_PRODUCT) Version $(VERSIONPKG)
#STRIPTOOL="$CONFIG_CROSS_COMPILER_PATH"/mipsel-linux-sstrip
############################################################################
#
# Lets work out what the user wants, and if they have configured us yet
#

ifeq (.config,$(wildcard .config))
include .config

ifeq ($(CONFIG_UCLIBC_0_9_33_2),y)
NEW_LIB = uClibc-0.9.33.2
NEW_LIB_ONLY = uClibc-0.9.33.2_only
endif

#changed by Steven Liu
#all: ucfront cksum subdirs romfs image
all: ap uClibc++_only $(NEW_LIB_ONLY) lib_only modules user_only romfs linux image
else
all: config_error
endif

############################################################################
#
# Get the core stuff worked out
#

LINUXDIR = $(CONFIG_LINUXDIR)
LIBCDIR  = $(CONFIG_LIBCDIR)
ROOTDIR  = $(shell pwd)
PATH	 := $(PATH):$(ROOTDIR)/tools
HOSTCC   = cc
IMAGEDIR = $(ROOTDIR)/images
ROMFSDIR = $(ROOTDIR)/romfs
ROMFSINST= romfs-inst.sh
SCRIPTSDIR = $(ROOTDIR)/config/scripts
TFTPDIR    = /tftpboot
BUILD_START_STRING ?= $(shell date "+%a, %d %b %Y %T %z")

############################################################################
#
# prepare configs, after define ROOTDIR and before -include $(LINUXDIR)/.config
#

export PROFILE ?= X3700
export PRODUCTDIR ?= $(ROOTDIR)/project/product/$(PROFILE)
include $(PRODUCTDIR)/router.mk
$(shell cp $(PRODUCTDIR)/linux.config $(LINUXDIR)/.config)
$(shell touch $(LINUXDIR)/.config)

.PHONY: ap
ap: acos_prepare tools gpl acos 

.PHONY: tools
tools:
	$(MAKE) -C tools

.PHONY: acos
acos: acos_prepare uClibc++_only $(NEW_LIB_ONLY) lib_only user_only
	$(MAKE) -C ap/acos

.PHONY: gpl
gpl: acos_prepare gpl_prepare uClibc++_only $(NEW_LIB_ONLY) lib_only user_only
	$(MAKE) -C ap/gpl

.PHONY: tools_clean
tools_clean:
	$(MAKE) -C tools clean

.PHONY: ap_clean
ap_clean: acos_clean gpl_clean

.PHONY: acos_clean
acos_clean:
	$(MAKE) -C ap/acos clean

.PHONY: gpl_clean
gpl_clean:
	$(MAKE) -C ap/gpl clean

.PHONY: acos_file_prepare
acos_file_prepare:
	@cp $(PRODUCTDIR)/ambitCfg.h project/acos/include/ambitCfg.h
	@cp $(PRODUCTDIR)/compatible.txt project/acos/compatible.txt
	@cp $(PRODUCTDIR)/string_table ap/acos/www/string_table_$(PROFILE)
	@cp $(PRODUCTDIR)/img/* ap/acos/www/img/
	@cp $(PRODUCTDIR)/wlan_region.c ap/acos/shared/wlan_region.c
	@cp $(PRODUCTDIR)/icon/* project/acos/icon/
	@cp $(PRODUCTDIR)/acos.in project/acos/config.in
	@cp $(PRODUCTDIR)/acos.mk project/acos/config.mk
	@cp $(PRODUCTDIR)/acos.makefile project/acos/Makefile
	@cp $(PRODUCTDIR)/gpl.in project/gpl/config.in
	@cp $(PRODUCTDIR)/gpl.mk project/gpl/config.mk
	@cp $(PRODUCTDIR)/gpl.makefile project/gpl/Makefile

KERNEL_FILES := $(LINUXDIR)/scripts/mod/modpost
KERNEL_FILES += $(LINUXDIR)/include/generated/bounds.h
KERNEL_FILES += $(LINUXDIR)/include/generated/asm-offsets.h

$(KERNEL_FILES): $(LINUXDIR)/Makefile
	$(MAKE) -C $(LINUXDIR) modules_prepare

.PHONY: kernel_file_prepare
kernel_file_prepare: $(KERNEL_FILES)

.PHONY: acos_prepare
acos_prepare:
	$(MAKE) acos_file_prepare
	@cp -bfS .old $(PRODUCTDIR)/compatible.txt .product
	@if ! cmp -s .product .product.old; then \
		$(MAKE) clean || exit 1; \
		$(MAKE) -C $(LINUXDIR) silentoldconfig || exit 1; \
	 fi
	$(MAKE) kernel_file_prepare


.PHONY: gpl_prepare
gpl_prepare:
	echo $(INSTALLDIR)
	$(MAKE) -C $(ROOTDIR)/ap/gpl CROSS=$(CROSS_COMPILE) STRIPTOOL=$(STRIP) openssl_make
#	$(MAKE) -C $(ROOTDIR)/ap/gpl/openssl-1.0.2n CROSS=$(CROSS_COMPILE) STRIPTOOL=$(STRIP) INSTALLDIR=$(INSTALLDIR) install
############################################################################

#
# For linux-2.6 kernel, it doesn't know VPATH parameter in Makefile.
# That means object files will be generated at source directory.
#
# When we want to built both AP and STA driver in root filesystem, we MUST disable compiler's -j option to 
# avoid different CPU build WiFi driver at the same time.
#
# by Steven
#
-include $(LINUXDIR)/.config


#uncomment this line if you want to use single cpu to compiile your code.
HOST_NCPU = 1

LINUX_CONFIG  = $(ROOTDIR)/$(LINUXDIR)/.config
CONFIG_CONFIG = $(ROOTDIR)/config/.config
BUSYBOX_CONFIG = $(ROOTDIR)/user/busybox/.config
MODULES_CONFIG = $(ROOTDIR)/modules/.config


CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

ifeq (config.arch,$(wildcard config.arch))
ifeq ($(filter %_default, $(MAKECMDGOALS)),)
include config.arch
ARCH_CONFIG = $(ROOTDIR)/config.arch
export ARCH_CONFIG
endif
endif

# May use a different compiler for the kernel
KERNEL_CROSS_COMPILE ?= $(CROSS_COMPILE)
#KERNEL_CROSS_COMPILE = /opt/timesys/toolchains/mipsisa32r2el-linux/bin/mipsel-linux-
ifneq ($(SUBARCH),)
# Using UML, so make the kernel and non-kernel with different ARCHs
MAKEARCH = $(MAKE) ARCH=$(SUBARCH) CROSS_COMPILE=$(CROSS_COMPILE)
MAKEARCH_KERNEL = $(MAKE) ARCH=$(ARCH) SUBARCH=$(SUBARCH) CROSS_COMPILE=$(KERNEL_CROSS_COMPILE)
else
MAKEARCH = $(MAKE) ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE)
MAKEARCH_KERNEL = $(MAKE)  ARCH=$(ARCH) CROSS_COMPILE=$(KERNEL_CROSS_COMPILE)
endif
DIRS    = ap/acos ap/gpl $(ROOTDIR)/vendors include uClibc++ user $(NEW_LIB) lib

export VENDOR PRODUCT ROOTDIR LINUXDIR HOSTCC CONFIG_SHELL
export CONFIG_CONFIG BUSYBOX_CONFIG LINUX_CONFIG MODULES_CONFIG ROMFSDIR SCRIPTSDIR
export VERSIONPKG VERSIONSTR ROMFSINST PATH IMAGEDIR RELFILES TFTPDIR
export BUILD_START_STRING
export HOST_NCPU

.PHONY: ucfront
ucfront: tools/ucfront/*.c
	$(MAKE) -C tools/ucfront
	ln -sf $(ROOTDIR)/tools/ucfront/ucfront tools/ucfront-gcc
	ln -sf $(ROOTDIR)/tools/ucfront/ucfront tools/ucfront-g++
	ln -sf $(ROOTDIR)/tools/ucfront/ucfront-ld tools/ucfront-ld

.PHONY: cksum
cksum: tools/sg-cksum/*.c
	$(MAKE) -C tools/sg-cksum
	ln -sf $(ROOTDIR)/tools/sg-cksum/cksum tools/cksum

############################################################################

#
# Config stuff,  we recall ourselves to load the new config.arch before
# running the kernel and other config scripts
#

.PHONY: config.tk config.in

config.in:
	@chmod u+x config/mkconfig
	config/mkconfig > config.in

config.tk: config.in
	$(MAKE) -C $(SCRIPTSDIR) tkparse
	ARCH=dummy $(SCRIPTSDIR)/tkparse < config.in > config.tmp
	@if [ -f /usr/local/bin/wish ];	then \
		echo '#!'"/usr/local/bin/wish -f" > config.tk; \
	else \
		echo '#!'"/usr/bin/wish -f" > config.tk; \
	fi
	cat $(SCRIPTSDIR)/header.tk >> ./config.tk
	cat config.tmp >> config.tk
	rm -f config.tmp
	echo "set defaults \"/dev/null\"" >> config.tk
	echo "set help_file \"config/Configure.help\"" >> config.tk
	cat $(SCRIPTSDIR)/tail.tk >> config.tk
	chmod 755 config.tk

.PHONY: xconfig
xconfig: config.tk
	@wish -f config.tk
	@if [ ! -f .config ]; then \
		echo; \
		echo "You have not saved your config, please re-run make config"; \
		echo; \
		exit 1; \
	 fi
	@chmod u+x config/setconfig
	@config/setconfig defaults
	@if egrep "^CONFIG_DEFAULTS_KERNEL=y" .config > /dev/null; then \
		$(MAKE) linux_xconfig; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_MODULES=y" .config > /dev/null; then \
		$(MAKE) modules_xconfig; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_VENDOR=y" .config > /dev/null; then \
		$(MAKE) config_xconfig; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_BUSYBOX=y" .config > /dev/null; then \
		$(MAKE) -C user/busybox menuconfig; \
	 fi
ifeq ($(CONFIG_UCLIBC_0_9_33_2),y)
	@if egrep "^CONFIG_DEFAULTS_UCLIBC=y" .config > /dev/null; then \
		$(MAKE) -C uClibc-0.9.33.2 menuconfig; \
	 fi
else
	@if egrep "^CONFIG_DEFAULTS_UCLIBC=y" .config > /dev/null; then \
		$(MAKE) -C lib menuconfig; \
	 fi
endif
	@if egrep "^CONFIG_DEFAULTS_UCLIBC_PLUS_PLUS=y" .config > /dev/null; then \
		$(MAKE) -C uClibc++ menuconfig; \
	 fi
	@config/setconfig final

.PHONY: config
config: config.in
	@HELP_FILE=config/Configure.help \
		$(CONFIG_SHELL) $(SCRIPTSDIR)/Configure config.in
	@chmod u+x config/setconfig
	@config/setconfig defaults
	@if egrep "^CONFIG_DEFAULTS_KERNEL=y" .config > /dev/null; then \
		$(MAKE) linux_config; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_MODULES=y" .config > /dev/null; then \
		$(MAKE) modules_config; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_VENDOR=y" .config > /dev/null; then \
		$(MAKE) config_config; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_BUSYBOX=y" .config > /dev/null; then \
		$(MAKE) -C user/busybox menuconfig; \
	 fi
ifeq ($(CONFIG_UCLIBC_0_9_33_2),y)
	@if egrep "^CONFIG_DEFAULTS_UCLIBC=y" .config > /dev/null; then \
		$(MAKE) -C uClibc-0.9.33.2 menuconfig; \
	 fi
else
	@if egrep "^CONFIG_DEFAULTS_UCLIBC=y" .config > /dev/null; then \
		$(MAKE) -C lib menuconfig; \
	 fi
endif
	@if egrep "^CONFIG_DEFAULTS_UCLIBC_PLUS_PLUS=y" .config > /dev/null; then \
		$(MAKE) -C uClibc++ menuconfig; \
	 fi
	@config/setconfig final

.PHONY: menuconfig
menuconfig: config.in
	$(MAKE) -C $(SCRIPTSDIR)/lxdialog all
	@HELP_FILE=config/Configure.help \
		$(CONFIG_SHELL) $(SCRIPTSDIR)/Menuconfig config.in
	@if [ ! -f .config ]; then \
		echo; \
		echo "You have not saved your config, please re-run make config"; \
		echo; \
		exit 1; \
	 fi
	@chmod u+x config/setconfig
	@config/setconfig defaults
	@if egrep "^CONFIG_DEFAULTS_KERNEL=y" .config > /dev/null; then \
		$(MAKE) linux_menuconfig; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_MODULES=y" .config > /dev/null; then \
		$(MAKE) modules_menuconfig; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_VENDOR=y" .config > /dev/null; then \
		$(MAKE) config_menuconfig; \
	 fi
	@if egrep "^CONFIG_DEFAULTS_BUSYBOX=y" .config > /dev/null; then \
		$(MAKE) -C user/busybox menuconfig; \
	 fi
ifeq ($(CONFIG_UCLIBC_0_9_33_2),y)
	@if egrep "^CONFIG_DEFAULTS_UCLIBC=y" .config > /dev/null; then \
		$(MAKE) -C uClibc-0.9.33.2 menuconfig; \
	 fi
else
	@if egrep "^CONFIG_DEFAULTS_UCLIBC=y" .config > /dev/null; then \
		$(MAKE) -C lib menuconfig; \
	 fi
endif
	@if egrep "^CONFIG_DEFAULTS_UCLIBC_PLUS_PLUS=y" .config > /dev/null; then \
		$(MAKE) -C uClibc++ menuconfig; \
	 fi
	@config/setconfig final

.PHONY: oldconfig
oldconfig: config.in
	@HELP_FILE=config/Configure.help \
		$(CONFIG_SHELL) $(SCRIPTSDIR)/Configure -d config.in
	@$(MAKE) oldconfig_linux
	@$(MAKE) oldconfig_modules
	@$(MAKE) oldconfig_config
	@chmod u+x config/setconfig
	@config/setconfig final

.PHONY: modules
modules:
	. $(LINUXDIR)/.config; if [ "$$CONFIG_MODULES" = "y" ]; then \
		[ -d $(LINUXDIR)/modules ] || mkdir $(LINUXDIR)/modules; \
		$(MAKEARCH_KERNEL) -C $(LINUXDIR) modules; \
	fi

.PHONY: modules_install
modules_install:
	. $(LINUXDIR)/.config; if [ "$$CONFIG_MODULES" = "y" ]; then \
		[ -d $(ROMFSDIR)/lib/modules ] || mkdir -p $(ROMFSDIR)/lib/modules; \
		$(MAKEARCH_KERNEL) -C $(LINUXDIR) INSTALL_MOD_PATH=$(ROMFSDIR) DEPMOD="../user/busybox/examples/depmod.pl" modules_install; \
		rm -f $(ROMFSDIR)/lib/modules/*/build; \
		rm -f $(ROMFSDIR)/lib/modules/*/source; \
		find $(ROMFSDIR)/lib/modules -type f -name "*o" | xargs -r $(STRIP) -R .comment -R .note -g --strip-unneeded; \
	fi

linux_xconfig:
	KCONFIG_NOTIMESTAMP=1 $(MAKEARCH_KERNEL) -C $(LINUXDIR) xconfig
linux_menuconfig:
	KCONFIG_NOTIMESTAMP=1 $(MAKEARCH_KERNEL) -C $(LINUXDIR) menuconfig
linux_config:
	KCONFIG_NOTIMESTAMP=1 $(MAKEARCH_KERNEL) -C $(LINUXDIR) config
modules_xconfig:
	[ ! -d modules ] || $(MAKEARCH) -C modules xconfig
modules_menuconfig:
	[ ! -d modules ] || $(MAKEARCH) -C modules menuconfig
modules_config:
	[ ! -d modules ] || $(MAKEARCH) -C modules config
modules_clean:
	-[ ! -d modules ] || $(MAKEARCH) -C modules clean
config_xconfig:
	$(MAKEARCH) -C config xconfig
config_menuconfig:
	$(MAKEARCH) -C config menuconfig
config_config:
	$(MAKEARCH) -C config config
oldconfig_config:
	$(MAKEARCH) -C config oldconfig
oldconfig_modules:
	[ ! -d modules ] || $(MAKEARCH) -C modules oldconfig
oldconfig_linux:
	KCONFIG_NOTIMESTAMP=1 $(MAKEARCH_KERNEL) -C $(LINUXDIR) oldconfig

=== lib/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000-2003 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA


#--------------------------------------------------------------
# You shouldn't need to mess with anything beyond this point...
#--------------------------------------------------------------
noconfig_targets := menuconfig config oldconfig randconfig \
	defconfig allyesconfig allnoconfig clean distclean \
	release tags TAGS
TOPDIR=./
include Rules.mak
-include $(CONFIG_CONFIG)

DIRS=
ifeq ($(CONFIG_UCLIBC_0_9_28),y) 
DIRS += ldso libc
ifeq ($(strip $(UCLIBC_HAS_GETTEXT_AWARENESS)),y)
    DIRS += libintl
endif
ifeq ($(CONFIG_LIB_CRYPT_FORCE),y)
    DIRS += libcrypt
endif
ifeq ($(CONFIG_LIB_RESOLV_FORCE),y)
    DIRS += libresolv
endif
ifeq ($(CONFIG_LIB_NSL_FORCE),y)
    DIRS += libnsl
endif
ifeq ($(CONFIG_LIB_UTIL_FORCE),y)
    DIRS += libutil
endif
ifeq ($(CONFIG_LIB_RT_FORCE),y)
    DIRS += librt
endif
ifeq ($(CONFIG_LIB_LIBM_FORCE),y)
    DIRS += libm
endif
ifeq ($(CONFIG_LIB_LIBPTHREAD_FORCE),y)
    DIRS += libpthread
endif
endif

ifeq ($(CONFIG_LIB_LIBGMP_FORCE),y)
    DIRS += libgmp
endif
ifeq ($(CONFIG_LIB_ZLIB_FORCE),y)
    DIRS += zlib-1.2.3
endif
ifeq ($(CONFIG_LIB_LIBNVRAM_FORCE),y)
    DIRS += libnvram
endif
ifeq ($(CONFIG_LIB_LIBNTFS3G_FORCE),y)
    DIRS += libntfs-3g
endif
ifeq ($(CONFIG_LIB_LIBBT_FORCE),y)
    DIRS += libbluetooth
endif
ifeq ($(CONFIG_LIB_READLINE_FORCE),y)
    DIRS += libreadline
endif
ifeq ($(CONFIG_LIB_LIBSQLITE3_FORCE),y)
    DIRS += libsqlite3
endif
ifeq ($(CONFIG_LIB_LIBEXIF_FORCE),y)
    DIRS += libexif
endif
ifeq ($(CONFIG_LIB_LIBOGG_FORCE),y)
    DIRS += libogg
endif
ifeq ($(CONFIG_LIB_LIBVORBIS_FORCE),y)
    DIRS += libvorbis
endif
ifeq ($(CONFIG_LIB_LIBFLAC_FORCE),y)
    DIRS += libflac
endif
ifeq ($(CONFIG_LIB_LIBJPEG_FORCE),y)
    DIRS += libjpeg
endif
ifeq ($(CONFIG_LIB_LIBPCAP_FORCE),y)
    DIRS += libpcap-1.0.0
endif
ifeq ($(CONFIG_LIB_LIBEVENT_FORCE),y)
     DIRS += libevent-2.0.2-alpha
endif
ifeq ($(CONFIG_LIB_NCURSE_FORCE),y)
    DIRS += libncurses-5.7
endif
ifeq ($(CONFIG_LIB_FLEX_FORCE),y)
    DIRS += libflex
endif
ifeq ($(CONFIG_LIB_LIBUPNP_FORCE),y)
    DIRS += libupnp
endif
ifeq ($(CONFIG_LIB_LIBUPNP166_FORCE),y)
    DIRS += libupnp-1.6.6
endif
ifeq ($(CONFIG_LIB_LIBUPNP166_DMS_FORCE),y)
    DIRS += libupnp-1.6.6-dms
endif
ifeq ($(CONFIG_LIB_LIBFFMPEG_FORCE),y)
    DIRS += libffmpeg-0.5
endif
ifeq ($(CONFIG_LIB_LIBDLNA_FORCE),y)
    DIRS += libdlna-0.2.3
endif
ifeq ($(CONFIG_LIB_LIBGDBM_FORCE),y)
    DIRS += libgdbm-1.8.3
endif
ifeq ($(CONFIG_LIB_LIBID3TAG_FORCE),y)
    DIRS += libid3tag-0.15.1b
endif
ifeq ($(CONFIG_LIB_LIBZEBRA_FORCE),y)
    DIRS += libzebra
endif
ifeq ($(CONFIG_LIB_USB0112_FORCE),y)
    DIRS += libusb-0.1.12
endif
ifeq ($(CONFIG_LIB_USB100_FORCE),y)
    DIRS += libusb-1.0.0
endif
ifeq ($(CONFIG_LIB_PCRE_FORCE),y)
    DIRS += pcre-8.01
endif
ifeq ($(CONFIG_LIB_VSTR_FORCE),y)
    DIRS += vstr-1.0.15
endif

# mtd-utils-1.5.0

ifeq ($(CONFIG_LIB_LZO_FORCE),y)
    DIRS += lzo-2.03
endif
ifeq ($(CONFIG_LIB_E2FSPROGS_FORCE),y)
    DIRS += e2fsprogs-1.41.3
endif
# end


ifeq ($(strip $(HAVE_DOT_CONFIG)),y)

all: headers pregen subdirs shared finished

# In this section, we need .config
-include .config.cmd

shared: subdirs
ifeq ($(strip $(HAVE_SHARED)),y)
	$(SECHO)
	$(SECHO) Building shared libraries ...
	$(SECHO)
ifeq ($(CONFIG_UCLIBC_0_9_28),y) 
	@$(MAKE) -C libc shared
	@$(MAKE) -C ldso shared

ifeq ($(CONFIG_LIB_CRYPT_FORCE),y)
	@$(MAKE) -C libcrypt shared
endif
ifeq ($(CONFIG_LIB_RESOLV_FORCE),y)
	@$(MAKE) -C libresolv shared
endif
ifeq ($(CONFIG_LIB_NSL_FORCE),y)
	@$(MAKE) -C libnsl shared
endif
ifeq ($(CONFIG_LIB_UTIL_FORCE),y)
	@$(MAKE) -C libutil shared
endif
ifeq ($(CONFIG_LIB_RT_FORCE),y)
	@$(MAKE) -C librt shared
endif
ifeq ($(CONFIG_LIB_LIBM_FORCE),y)
	@$(MAKE) -C libm shared
endif
ifeq ($(CONFIG_LIB_LIBPTHREAD_FORCE),y)
	@$(MAKE) -C libpthread shared
endif
ifeq ($(strip $(UCLIBC_HAS_GETTEXT_AWARENESS)),y)
	@$(MAKE) -C libintl shared
endif
endif

ifeq ($(CONFIG_LIB_LIBNVRAM_FORCE),y)
	@$(MAKE) -C libnvram shared
endif
ifeq ($(CONFIG_LIB_LIBNTFS3G_FORCE),y)
	@$(MAKE) -C libntfs-3g shared
endif
ifeq ($(CONFIG_LIB_LIBBT_FORCE),y)
	@$(MAKE) -C libbluetooth shared
endif
ifeq ($(CONFIG_LIB_READLINE_FORCE),y)
	@$(MAKE) -C libreadline shared
endif
ifeq ($(CONFIG_LIB_LIBSQLITE3_FORCE),y)
	@$(MAKE) -C libsqlite3 shared
endif
ifeq ($(CONFIG_LIB_LIBEXIF_FORCE),y)
	@$(MAKE) -C libexif shared
endif
ifeq ($(CONFIG_LIB_LIBOGG_FORCE),y)
	@$(MAKE) -C libogg shared
endif
ifeq ($(CONFIG_LIB_LIBVORBIS_FORCE),y)
	@$(MAKE) -C libvorbis shared
endif
ifeq ($(CONFIG_LIB_LIBFLAC_FORCE),y)
	@$(MAKE) -C libflac shared
endif
ifeq ($(CONFIG_LIB_LIBJPEG_FORCE),y)
	@$(MAKE) -C libjpeg shared
endif
ifeq ($(CONFIG_LIB_LIBPCAP_FORCE),y)
	@$(MAKE) -C libpcap-1.0.0 shared
endif
ifeq ($(CONFIG_LIB_LIBEVENT_FORCE),y)
	@$(MAKE) -C libevent-2.0.2-alpha shared
endif
ifeq ($(CONFIG_LIB_NCURSE_FORCE),y)
	@$(MAKE) -C libncurses-5.7 shared
endif
ifeq ($(CONFIG_LIB_FLEX_FORCE),y)
	@$(MAKE) -C libflex shared
endif
ifeq ($(CONFIG_LIB_LIBUPNP_FORCE),y)
	@$(MAKE) -C libupnp shared
endif
ifeq ($(CONFIG_LIB_LIBUPNP166_FORCE),y)
	@$(MAKE) -C libupnp-1.6.6
endif
ifeq ($(CONFIG_LIB_LIBUPNP166_DMS_FORCE),y)
	@$(MAKE) -C libupnp-1.6.6-dms
endif
ifeq ($(CONFIG_LIB_LIBFFMPEG_FORCE),y)
	@$(MAKE) -C libffmpeg-0.5
endif
ifeq ($(CONFIG_LIB_LIBDLNA_FORCE),y)
	@$(MAKE) -C libdlna-0.2.3
endif
ifeq ($(CONFIG_LIB_LIBGDBM_FORCE),y)
	@$(MAKE) -C libgdbm-1.8.3 shared
endif
ifeq ($(CONFIG_LIB_LIBID3TAG_FORCE),y)
	@$(MAKE) -C libid3tag-0.15.1b shared
endif
ifeq ($(CONFIG_LIB_LIBGMP_FORCE),y)
	@$(MAKE) -C libgmp shared
endif
ifeq ($(CONFIG_LIB_ZLIB_FORCE),y)
	@$(MAKE) -C zlib-1.2.3 shared
endif
ifeq ($(CONFIG_LIB_LIBZEBRA_FORCE),y)
	@$(MAKE) -C libzebra shared
endif
ifeq ($(CONFIG_LIB_USB0112_FORCE),y)
	@$(MAKE) -C libusb-0.1.12 shared
endif
ifeq ($(CONFIG_LIB_USB100_FORCE),y)
	@$(MAKE) -C libusb-1.0.0 shared
endif
ifeq ($(CONFIG_LIB_PCRE_FORCE),y)
	@$(MAKE) -C pcre-8.01 shared
endif
ifeq ($(CONFIG_LIB_VSTR_FORCE),y)
	@$(MAKE) -C vstr-1.0.15 shared
endif
else
	$(SECHO)
	$(SECHO) Not building shared libraries ...
	$(SECHO)
endif

finished: shared
	$(SECHO)
	$(SECHO) Finally finished compiling ...
	$(SECHO)

include/bits/uClibc_config.h: .config
	@if [ ! -x ./extra/config/conf ] ; then \
	    $(MAKE) -C extra/config conf; \
	fi;
	$(RM) -r include/bits
	$(INSTALL) -d include/bits
	@./extra/config/conf -o extra/Configs/Config.in

# For the moment, we have to keep re-running this target 
# because the fix includes scripts rely on pre-processers 
# in order to generate the headers correctly :(.  That 
# means we can't use the $(HOSTCC) in order to get the 
# correct output.
ifeq ($(strip $(ARCH_HAS_MMU)),y)
export header_extra_args = 
else
export header_extra_args = -n
endif
headers: include/bits/uClibc_config.h
	@$(SHELL_SET_X); \
	./extra/scripts/fix_includes.sh \
		-k $(KERNEL_SOURCE) -t $(TARGET_ARCH) \
		$(header_extra_args)
	@cd include/bits; \
	set -e; \
	for i in `ls ../../libc/sysdeps/linux/common/bits/*.h` ; do \
		$(LN) -fs $$i .; \
	done; \
	if [ -d ../../libc/sysdeps/linux/$(TARGET_ARCH)/bits ] ; then \
		for i in `ls ../../libc/sysdeps/linux/$(TARGET_ARCH)/bits/*.h` ; do \
			$(LN) -fs $$i .; \
		done; \
	fi
	@cd include/sys; \
	set -e; \
	for i in `ls ../../libc/sysdeps/linux/common/sys/*.h` ; do \
		$(LN) -fs $$i .; \
	done; \
	if [ -d ../../libc/sysdeps/linux/$(TARGET_ARCH)/sys ] ; then \
		for i in `ls ../../libc/sysdeps/linux/$(TARGET_ARCH)/sys/*.h` ; do \
			$(LN) -fs $$i .; \
		done; \
	fi
	@cd $(TOPDIR); \
	set -e; \
	$(SHELL_SET_X); \
	TOPDIR=. CC="$(CC)" /bin/sh extra/scripts/gen_bits_syscall_h.sh > include/bits/sysnum.h.new; \
	if cmp include/bits/sysnum.h include/bits/sysnum.h.new >/dev/null 2>&1; then \
		$(RM) include/bits/sysnum.h.new; \
	else \
		mv -f include/bits/sysnum.h.new include/bits/sysnum.h; \
	fi
	$(MAKE) -C libc/sysdeps/linux/common headers
	$(MAKE) -C libc/sysdeps/linux/$(TARGET_ARCH) headers

# Command used to download source code
WGET:=wget --passive-ftp

LOCALE_DATA_FILENAME:=uClibc-locale-030818.tgz

pregen: headers
ifeq ($(strip $(UCLIBC_DOWNLOAD_PREGENERATED_LOCALE_DATA)),y)
	(cd extra/locale; \
	if [ ! -f $(LOCALE_DATA_FILENAME) ] ; then \
	$(WGET) http://www.uclibc.org/downloads/$(LOCALE_DATA_FILENAME) ; \
	fi );
endif
ifeq ($(strip $(UCLIBC_PREGENERATED_LOCALE_DATA)),y)
	(cd extra/locale; zcat $(LOCALE_DATA_FILENAME) | tar -xvf -)
	$(MAKE) -C extra/locale pregen
endif


subdirs: $(patsubst %, _dir_%, $(DIRS))
$(patsubst %, _dir_%, $(DIRS)): headers
	$(MAKE) -C $(patsubst _dir_%, %, $@)

tags:
	ctags -R

install: install_runtime install_dev finished2

#added by Steven Liu
romfs: install_runtime
#--


RUNTIME_PREFIX_LIB_FROM_DEVEL_PREFIX_LIB=$(shell extra/scripts/relative_path.sh $(DEVEL_PREFIX)lib $(RUNTIME_PREFIX)lib)

# Installs header files and development library links.
install_dev:
	$(INSTALL) -d $(PREFIX)$(DEVEL_PREFIX)lib
	$(INSTALL) -d $(PREFIX)$(DEVEL_PREFIX)include
	-$(INSTALL) -m 644 lib/*.[ao] $(PREFIX)$(DEVEL_PREFIX)lib/
	if [ "$(KERNEL_SOURCE)" == "$(DEVEL_PREFIX)" ] ; then \
		extra_exclude="--exclude include/linux --exclude include/asm'*'" ; \
	else \
		extra_exclude="" ; \
	fi ; \
	tar -chf - include --exclude .svn --exclude CVS $$extra_exclude \
		| tar -xf - -C $(PREFIX)$(DEVEL_PREFIX)
ifneq ($(strip $(UCLIBC_HAS_FLOATS)),y)
	# Remove floating point related headers since float support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/complex.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/fpu_control.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/ieee754.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/math.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/tgmath.h
endif
ifneq ($(strip $(UCLIBC_HAS_WCHAR)),y)
	# Remove wide char headers since wide char support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/wctype.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/wchar.h
endif
ifneq ($(strip $(UCLIBC_HAS_LOCALE)),y)
	# Remove iconv header since locale support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/iconv.h
endif
ifneq ($(strip $(UCLIBC_HAS_GLIBC_CUSTOM_PRINTF)),y)
	# Remove printf header since custom print specifier support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/printf.h
endif
ifneq ($(strip $(UCLIBC_HAS_XLOCALE)),y)
	# Remove xlocale header since extended locale support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/xlocale.h
endif
ifneq ($(strip $(UCLIBC_HAS_GETTEXT_AWARENESS)),y)
	# Remove libintl header since gettext support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/libintl.h
endif
ifneq ($(strip $(UCLIBC_HAS_REGEX)),y)
	# Remove regex headers since regex support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/regex.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/regexp.h
endif
ifneq ($(strip $(UCLIBC_HAS_WORDEXP)),y)
	# Remove wordexp header since wordexp support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/wordexp.h
endif
ifneq ($(strip $(UCLIBC_HAS_FTW)),y)
	# Remove ftw header since ftw support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/ftw.h
endif
ifneq ($(strip $(UCLIBC_HAS_GLOB)),y)
	# Remove glob header since glob support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/glob.h
endif
ifneq ($(strip $(UCLIBC_HAS_GNU_GETOPT)),y)

=== linux-2.6.36.x/Makefile ===
VERSION = 2
PATCHLEVEL = 6
SUBLEVEL = 36
EXTRAVERSION =
NAME = Flesh-Eating Bats with Fangs

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not:
# o  use make's built-in rules and variables
#    (this increases performance and avoids hard-to-debug behaviour);
# o  print "Entering directory ...";
MAKEFLAGS += -rR --no-print-directory

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/sparse.txt" for more details, including
# where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif

ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	$(Q)@:

sub-make: FORCE
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile \
	$(filter-out _all sub-make,$(MAKECMDGOALS))

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH


# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and 
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ \
				  -e s/ppc.*/powerpc/ -e s/mips.*/mips/ \
				  -e s/sh[234].*/sh/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# A third alternative is to store a setting in .config so that plain
# "make" in the configured kernel build directory always uses that.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
export KBUILD_BUILDHOST := $(SUBARCH)
ARCH		?= mips
CROSS_COMPILE	?= $(CONFIG_CROSS_COMPILE:"%"=%)

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86
ifeq ($(ARCH),i386)
        SRCARCH := x86
endif
ifeq ($(ARCH),x86_64)
        SRCARCH := x86
endif

# Additional ARCH settings for sparc
ifeq ($(ARCH),sparc64)
       SRCARCH := sparc
endif

# Additional ARCH settings for sh
ifeq ($(ARCH),sh64)
       SRCARCH := sh
endif

# Where to locate arch specific headers
hdr-arch  := $(SRCARCH)

ifeq ($(ARCH),m68knommu)
       hdr-arch  := m68k
endif

KCONFIG_CONFIG	?= .config

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC       = gcc
HOSTCXX      = g++
HOSTCFLAGS   = -Wall -Wmissing-prototypes -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS = -O2

# Decide whether to build built-in, modular, or both.
# Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are up to date before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed. 
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# We need some generic definitions (do not try to remake the file).
$(srctree)/scripts/Kbuild.include: ;
include $(srctree)/scripts/Kbuild.include

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
INSTALLKERNEL  := installkernel
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
		  -Wbitwise -Wno-return-void $(CF)
CFLAGS_MODULE   =
AFLAGS_MODULE   =
LDFLAGS_MODULE  =
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=
CFLAGS_GCOV	= -fprofile-arcs -ftest-coverage


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := -I$(srctree)/arch/$(hdr-arch)/include -Iinclude \
                   $(if $(KBUILD_SRC), -I$(srctree)/include) \
                   -include include/generated/autoconf.h

KBUILD_CPPFLAGS := -D__KERNEL__

KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
		   -fno-strict-aliasing -fno-common \
		   -Werror-implicit-function-declaration \
		   -Wno-format-security \
		   -fno-delete-null-pointer-checks
KBUILD_AFLAGS_KERNEL :=
KBUILD_CFLAGS_KERNEL :=
KBUILD_AFLAGS   := -D__ASSEMBLY__
KBUILD_AFLAGS_MODULE  := -DMODULE
KBUILD_CFLAGS_MODULE  := -DMODULE
KBUILD_LDFLAGS_MODULE := -T $(srctree)/scripts/module-common.lds

-include $(srctree)/../project/product/$(PROFILE)/linux.mk

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
KERNELRELEASE = $(shell cat include/config/kernel.release 2> /dev/null)
KERNELVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

export VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION
export ARCH SRCARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC
export CPP AR NM STRIP OBJCOPY OBJDUMP
export MAKE AWK GENKSYMS INSTALLKERNEL PERL UTS_MACHINE
export HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export KBUILD_CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export KBUILD_CFLAGS CFLAGS_KERNEL CFLAGS_MODULE CFLAGS_GCOV
export KBUILD_AFLAGS AFLAGS_KERNEL AFLAGS_MODULE
export KBUILD_AFLAGS_MODULE KBUILD_CFLAGS_MODULE KBUILD_LDFLAGS_MODULE
export KBUILD_AFLAGS_KERNEL KBUILD_CFLAGS_KERNEL

# When compiling out-of-tree modules, put MODVERDIR in the module

=== tools/Makefile ===

tools_dir := $(shell pwd)
packet_dir := $(tools_dir)/packet_src
lzma_dir := $(tools_dir)/lzma-4.32.7
xz_dir := $(tools_dir)/xz-5.0.3
squashfs_dir := $(tools_dir)/squashfs4.2/squashfs-tools

liblzma_dir := /usr/local/lib

CFLAGS      :=
LDFLAGS     :=
CXXFLAGS    :=

AS          := as
LD          := ld
CC          := gcc
CXX         := g++
CPP         := cpp
AR          := ar
NM          := nm
STRIP       := strip
OBJCOPY     := objcopy
OBJDUMP     := objdump
RANLIB      := ranlib
SIZE        := size

tools_obj = packet lzma xz squashfs
tools_clean_obj = packet-clean lzma-clean xz-clean squashfs-clean

.PHONY: all clean
.PHONY: $(tools_obj) $(tools_clean_obj)

all: $(tools_obj)

clean: $(tools_clean_obj)

packet:
	[ ! -d $(packet_dir) ] || [ ! -f $(packet_dir)/Makefile ] || $(MAKE) -C $(packet_dir)
	[ ! -d $(packet_dir) ] || install -D -m 755 $(packet_dir)/packet .

lzma:
	[ ! -d $(lzma_dir) ] || [ -f $(lzma_dir)/Makefile ] || ( cd $(lzma_dir) && ./configure && cd ..)
	[ ! -d $(lzma_dir) ] || [ ! -f $(lzma_dir)/Makefile ] || $(MAKE) -C $(lzma_dir)
	[ ! -d $(lzma_dir) ] || install -D -m 755 $(lzma_dir)/src/lzma/lzma .

xz:
	[ ! -d $(xz_dir) ] || [ -f $(xz_dir)/Makefile ] || ( cd $(xz_dir) && ./configure && cd ..)
	[ ! -d $(xz_dir) ] || [ ! -f $(xz_dir)/Makefile ] || $(MAKE) -C $(xz_dir)
	[ ! -d $(xz_dir) ] || install -D -m 755 $(xz_dir)/src/xz/.libs/xz .

squashfs:
	[ ! -d $(squashfs_dir) ] || [ ! -f $(squashfs_dir)/Makefile ] \
		|| $(MAKE) -C $(squashfs_dir) EXTRA_LDFLAGS="-Wl,-rpath -Wl,$(liblzma_dir)"
	[ ! -d $(squashfs_dir) ] || install -D -m 755 $(squashfs_dir)/mksquashfs .

packet-clean:
	[ ! -d $(packet_dir) ] || [ ! -f $(packet_dir)/Makefile ] || $(MAKE) -C $(packet_dir) clean
	rm -rf packet

lzma-clean:
	[ ! -d $(lzma_dir) ] || [ ! -f $(lzma_dir)/Makefile ] || $(MAKE) -C $(lzma_dir) distclean
	rm -rf lzma

xz-clean:
	[ ! -d $(xz_dir) ] || [ ! -f $(xz_dir)/Makefile ] || $(MAKE) -C $(xz_dir) distclean
	rm -rf xz

squashfs-clean:
	[ ! -d $(squashfs_dir) ] || [ ! -f $(squashfs_dir)/Makefile ] \
		|| $(MAKE) -C $(squashfs_dir) clean
	rm -rf mksquashfs

=== uClibc++/Makefile ===
MAKE    = make
SUBDIRS = bin include src

# User defines:

noconfig_targets := menuconfig config oldconfig randconfig \
	defconfig allyesconfig allnoconfig clean distclean \
	release tags TAGS

TOPDIR=./
include $(TOPDIR)Rules.mak
-include $(CONFIG_CONFIG)

all: headers
ifeq ($(CONFIG_LIB_LIBSTDC_PLUS_FORCE),y)
	for dir in $(SUBDIRS) ; do \
		$(MAKE) -C $$dir all; \
	done
endif

tests: all
	$(MAKE) -C tests all

check test: tests
	$(MAKE) -C tests test

clean:
	for dir in $(SUBDIRS) tests ; do \
		$(MAKE) -C $$dir clean; \
	done
	#$(MAKE) -C extra/locale clean
	$(RM) -f bin/g++-uc src/libstdc++*

distclean: clean
	$(MAKE) -C extra clean
	$(RM) .config .config.cmd .config.old
	$(RM) include/system_configuration.h

headers: include/system_configuration.h

romfs install:
ifeq ($(CONFIG_LIB_LIBSTDC_PLUS_FORCE),y)
	for dir in $(SUBDIRS) ; do \
		$(MAKE) -C $$dir install; \
	done
endif


#Menu configuration system

extra/config/conf:
	make -C extra/config conf

extra/config/mconf:
	make -C extra/config ncurses mconf

menuconfig: extra/config/mconf
	@./extra/config/mconf extra/Configs/Config.in

config: extra/config/conf
	@./extra/config/conf extra/Configs/Config.in

oldconfig: extra/config/conf
	@./extra/config/conf -o extra/Configs/Config.in

randconfig: extra/config/conf
	@./extra/config/conf -r extra/Configs/Config.in

allyesconfig: extra/config/conf
	@./extra/config/conf -y extra/Configs/Config.in

allnoconfig: extra/config/conf
	@./extra/config/conf -n extra/Configs/Config.in

defconfig: extra/config/conf
	@./extra/config/conf -d extra/Configs/Config.in

include/system_configuration.h: .config
	@if [ ! -x ./extra/config/conf ] ; then \
		make -C extra/config conf; \
	fi;
	@./extra/config/conf -o extra/Configs/Config.in

.config:
	$(MAKE) defconfig

=== uClibc-0.9.33.2/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000-2005 Erik Andersen <andersen@uclibc.org>
#
# Licensed under the LGPL v2.1, see the file COPYING.LIB in this tarball.
#

top_srcdir=./
top_builddir=$(if $(O),$(O),.)/
export top_builddir

# We do not need built-in implicit rules
MAKEFLAGS += -r
CONFIG_SHELL ?= /bin/sh
export CONFIG_SHELL

include $(top_srcdir)Makefile.in
include $(top_srcdir)Makerules
include $(top_srcdir)Makefile.help

romfs:

=== user/Makefile ===
#
#	Makefile -- Build instructions for user level apps
#

.EXPORT_ALL_VARIABLES:
.PHONY: config all romfs clean prune romfs.post

#
# Include architecture specific build rules.
#
ifndef ROOTDIR
ROOTDIR=..
endif

UCLINUX_BUILD_USER=1
-include $(LINUX_CONFIG)
-include $(CONFIG_CONFIG)
-include $(BUSYBOX_CONFIG)
-include $(ARCH_CONFIG)
-include $(MODULES_CONFIG)

VEND=$(ROOTDIR)/vendors

#
# must run the vendor build first
#
dir_v = $(VEND)/$(CONFIG_VENDOR)/$(CONFIG_PRODUCT)/.
dir_p = $(ROOTDIR)/prop

dir_y = 
dir_n =
dir_  =
dir_post_inst_y =

dir_$(CONFIG_USER_802_1X)		    += 802.1x
dir_$(CONFIG_USER_ACCEL_PPTP)		    += accel-pptp
dir_$(CONFIG_USER_ARPTABLES)		    += arptable-0.0.3
dir_$(CONFIG_USER_RT2561_802_1X)	    += rt61apd
dir_$(CONFIG_USER_BIGPOND) 		    += bigpond
dir_$(CONFIG_USER_BONNIE)		    += bonnie++
dir_$(CONFIG_USER_BRCTL_BRCTL)              += bridge-utils
dir_$(CONFIG_USER_BT_UTILS)                 += bt-utils
dir_$(CONFIG_USER_CACHEBENCH)		    += llcbench/cachebench
dir_$(CONFIG_USER_CPU)			    += cpu
dir_$(CONFIG_USER_CTORRENT)                 += ctorrent-dnh3.2
dir_$(CONFIG_USER_DHCP6)                    += dhcp6
dir_$(CONFIG_USER_DROPBEAR)                 += dropbear-0.52
dir_$(CONFIG_DHRYSTONE)		    	    += dhrystone
dir_$(CONFIG_DHCPFWD)		    	    += dhcpforwarder
dir_$(CONFIG_USER_DNSMASQ)                  += dnsmasq-2.40
dir_$(CONFIG_USER_DISKTYPE)		    += disktype-9
dir_$(CONFIG_USER_EBTABLES)		    += ebtables-v2.0.9-2
dir_$(CONFIG_USER_ECMH)			    += ecmh
dir_$(CONFIG_USER_ETHTOOL)		    += ethtool
dir_$(CONFIG_USER_GDBREPLAY)                += gdbserver
dir_$(CONFIG_USER_GDBSERVER)                += gdbserver
dir_$(CONFIG_USER_MATRIXSSL)                += matrixssl-1.8.3
dir_$(CONFIG_USER_NBENCH)                   += nbench-byte-2.2.3
dir_$(CONFIG_USER_GOAHEAD_HTTPD)            += goahead
ifeq ($(CONFIG_LINUXDIR), linux-2.6.21.x)
ifeq ($(CONFIG_RALINKAPP_SWQOS),y)
dir_$(CONFIG_USER_IPTABLES_IPTABLES)	    += iptables-1.4.0rc1
dir_$(CONFIG_USER_IPTABLES_IP6TABLES)	    += iptables-1.4.0rc1
else
dir_$(CONFIG_USER_IPTABLES_IPTABLES)   	    += iptables
dir_$(CONFIG_USER_IPTABLES_IP6TABLES)	    += iptables
endif
else #linux 2.4 or linux 2.6.36

ifeq ($(CONFIG_LINUXDIR), linux-2.6.36.x)
dir_$(CONFIG_USER_IPTABLES_IPTABLES)	    += iptables-1.4.10
dir_$(CONFIG_USER_IPTABLES_IP6TABLES)	    += iptables-1.4.10
else
ifeq ($(CONFIG_LINUXDIR), linux-2.6.36MT.x)
dir_$(CONFIG_USER_IPTABLES_IPTABLES)	    += iptables-1.4.10
dir_$(CONFIG_USER_IPTABLES_IP6TABLES)	    += iptables-1.4.10
else
dir_$(CONFIG_USER_IPTABLES_IPTABLES)	    += iptables
dir_$(CONFIG_USER_IPTABLES_IP6TABLES)	    += iptables
endif
endif
endif
dir_$(CONFIG_USER_IXIA_ENDPOINT_670)	    += ixia_endpoint
dir_$(CONFIG_USER_IXIA_ENDPOINT_730SP1)	    += ixia_endpoint_730sp1
dir_$(CONFIG_USER_IPERF)            	    += iperf-2.0.5
dir_$(CONFIG_USER_INADYN)                   += inadyn
dir_$(CONFIG_USER_IGMP_PROXY)  		    += igmpproxy
ifeq ($(CONFIG_LINUXDIR), linux-2.6.21.x)
dir_$(CONFIG_USER_IPROUTE2)          	    += iproute2-2.6.24-rc7
else
dir_$(CONFIG_USER_IPROUTE2)                 += iproute2-2.6.38
endif
dir_$(CONFIG_USER_LMBENCH3)		    += lmbench3
dir_$(CONFIG_USER_LLTD)			    += lldt
dir_$(CONFIG_USER_LSUSB)		    += lsusb
dir_$(CONFIG_USER_LIGHTY)		    += lighttpd-1.4.20
dir_$(CONFIG_USER_MINIUPNPD)		    += miniupnpd-1.6
dir_$(CONFIG_USER_MTDUTILS)                 += mtd-utils-1.5.0
dir_$(CONFIG_USER_MTD_WRITE)         	    += mtd_write
dir_$(CONFIG_USER_MKDOSFS)                  += mkdosfs-2.11
dir_$(CONFIG_USER_MPSTAT)                   += mpstat-0.1.1
dir_$(CONFIG_USER_NETCAT)		    += netcat
dir_$(CONFIG_USER_NETSTAT_NAT)		    += netstat-nat
dir_$(CONFIG_USER_NTPCLIENT_NTPCLIENT)      += ntpclient
dir_$(CONFIG_USER_NTPCLIENT_ADJTIMEX)       += ntpclient
dir_$(CONFIG_USER_NTFS3G)		    += ntfs-3g
dir_$(CONFIG_USER_NTFSPROGS)                += ntfsprogs
dir_$(CONFIG_USER_OPENSWAN)                 += openswan-2.6.38
dir_$(CONFIG_USER_OPENSWAN)                 += l2tpv3tun-0.2
dir_$(CONFIG_USER_OPENL2TP)                 += openl2tp-1.6
#dir_$(CONFIG_USER_OPENSSL)	   	    += openssl-0.9.8e
#dir_$(CONFIG_USER_OPENSSL)	   	    += openssl-1.0.2h
dir_$(CONFIG_USER_PARPROUTED)	   	    += parprouted-0.7
dir_$(CONFIG_USER_PPPOECD)                  += ppp-2.4.1/pppoecd
dir_$(CONFIG_USER_PPPD)                     += ppp-2.4.2
dir_$(CONFIG_USER_PPPD_PPPSTATS)            += ppp-2.4.2
dir_$(CONFIG_USER_PPPD_PPPDUMP)             += ppp-2.4.2
dir_$(CONFIG_USER_PPTP_CLIENT)              += pptp-client
dir_$(CONFIG_USER_PCIUTIL_LSPCI)            += pciutils-3.0.0
dir_$(CONFIG_USER_PCIUTIL_SETPCI)           += pciutils-3.0.0
dir_$(CONFIG_USER_P910ND)                   += p910nd-0.91
dir_$(CONFIG_USER_PROFTPD)                  += proftpd
dir_$(CONFIG_USER_RADVD)                    += radvd-1.0
dir_$(CONFIG_RALINKAPP)		    	    += rt2880_app
dir_$(CONFIG_USER_RP_L2TP)		    += rp-l2tp-0.4
dir_$(CONFIG_USER_RPPPPOE_RELAY)  	    += rp-pppoe-3.8
dir_$(CONFIG_USER_RPPPPOE_SNIFF)  	    += rp-pppoe-3.8
dir_$(CONFIG_USER_STRACE_STRACE)            += strace
dir_$(CONFIG_USER_STUPID_FTPD)              += stupid-ftpd
dir_$(CONFIG_USER_BUSYBOX_BUSYBOX)          += busybox
dir_$(CONFIG_SAMBA_3_0_2)		    += samba-3.0.2
dir_$(CONFIG_SAMBA_3_6_6)		    += samba-3.6.6
dir_$(CONFIG_USER_SNORT)                    += snort-2.8.5.2
dir_$(CONFIG_USER_TOTD)                     += totd-1.5
dir_$(CONFIG_USER_TCPDUMP)                  += tcpdump
dir_$(CONFIG_USER_TASKSET)                  += taskset
dir_$(CONFIG_USER_UVC_STREAM)		    += uvc_stream
dir_$(CONFIG_USER_UPNP_IGD)                 += linux-igd
dir_$(CONFIG_USER_WIRELESS_TOOLS)           += wireless_tools
dir_$(CONFIG_USER_WATCHDOG)           	    += watchdog-5.6
dir_$(CONFIG_USER_WPA_SUPPLICANT)	    += wpa_supplicant-0.5.7
dir_$(CONFIG_USER_WSC)			    += wsc_upnp
dir_$(CONFIG_USER_ETHTOOL)		    += ethtool
dir_$(CONFIG_USER_ZEBRA)		    += zebra-0.95a_ripd
dir_$(CONFIG_USER_USBMODESWITCH)	    += usb_modeswitch-0.9.5
dir_$(CONFIG_USER_COMGT)		    += comgt-0.32
dir_$(CONFIG_USER_SDPARM) 		    += sdparm-1.02
dir_$(CONFIG_USER_3G)	 		    += hso-1.6
dir_$(CONFIG_USER_SNMPD) 		    += snmpd
dir_$(CONFIG_USER_VMSTAT)		    += procps-3.2.8
dir_$(CONFIG_USER_ALSA_UTIL_1_0_27_2)		    += alsa-lib-1.0.27.2
dir_$(CONFIG_USER_ALSA_UTIL_1_0_27_2)		    += alsa-utils-1.0.27.2


#TEST
dir_$(CONFIG_USER_HELLO_WORLD)		    += hello_world
#--

# VoIP & TR069
ifeq ($(shell [[ "$(CONFIG_MTK_VOIP)" == "y" || "$(CONFIG_MTK_TR069)" == "y" ]] && echo true), true)
dir_y+=cpe_app
dir_post_inst_y+=cpe_app
endif

OPENSSL_DIR = $(ROOTDIR)/user/openssl-1.0.2h
#test
#dir_y=cpe_app


all: config 
	$(MAKE) -j$(HOST_NCPU) $(dir_y) $(dir_v) $(dir_p) || exit $$?

#
# add directory dependancies here
#
.PHONY: $(dir_y) $(dir_p)

$(dir_y) $(dir_p):  config
	[ ! -d "$@" ] || ( touch $@/.sgbuilt_user && $(MAKE) -j1 -C $@ ) || exit $$?

%_only:
	touch $(@:_only=)/.sgbuilt_user && $(MAKE) -j1 -C $(@:_only=)

%_clean:
	$(MAKE) -j1 -C $(@:_clean=) clean; rm -f $(@:_clean=)/.sgbuilt_user; true

romfs:
	for i in $(dir_y) $(dir_p) ; do \
		[ ! -d $$i ] || $(MAKE) -C $$i romfs || exit $$? ; \
	done

romfs.post:
	@echo "#########################################################################################"
	@echo "dir_post_inst_y = "$(dir_post_inst_y)
	@echo "#########################################################################################"
	for i in $(dir_post_inst_y) ; do \
		[ ! -d $$i ] || $(MAKE) -C $$i romfs.post || exit $$? ; \
	done

clean:
	-for i in $(dir_v) $(dir_y) $(dir_n) $(dir_) $(dir_p) ; do \
		if [ -f $$i/.sgbuilt_user ]; then \
			$(MAKE) -C $$i clean ; \
			rm -f $$i/.sgbuilt_user; \
		fi; \
	done

prune:
	-for i in  $(dir_n) $(dir_) ; do \
		found=0; \
		for j in  $(dir_y) ; do \
			if [ $$i == $$j ]; then \
				found=1; \
			fi; \
		done; \
		if [ $$found == 0 ]; then \
			[ "$$i" = "openswan" ] && make prune_openswan; \
			rm -fr $$i; \
		fi; \
	done

prune_openswan:
	@mkdir $(ROOTDIR)/$@
	@mv $(ROOTDIR)/openswan/linux/net/ipsec/{Config.in*,Kconfig} $(ROOTDIR)/$@/
	@rm -fr $(ROOTDIR)/openswan
	@mkdir -p $(ROOTDIR)/openswan/linux/net/ipsec
	@mv $(ROOTDIR)/$@/* $(ROOTDIR)/openswan/linux/net/ipsec/
	@rm -fr $(ROOTDIR)/$@
openssl_config:
	echo "$(ROOTDIR)"
	if [ ! -f ./openssl-1.0.2h/config.log ];then \
		cd openssl-1.0.2h && (CC=gcc CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS) -L$(OPENSSL_DIR)"  ./config no-asm shared --openssldir=$(TARGETDIR) && make depend) && \
		touch config.log; \
	fi

=== vendors/Makefile ===
#
#	Makefile -- Vendor specific build instructions
#

.EXPORT_ALL_VARIABLES:
.PHONY: all romfs image clean

#
# Include architecture specific build rules.
#

ifndef ROOTDIR
ROOTDIR=..
endif

UCLINUX_BUILD_USER=1
-include $(LINUX_CONFIG)
-include $(CONFIG_CONFIG)
-include $(ARCH_CONFIG)
-include $(MODULES_CONFIG)

VEND=$(ROOTDIR)/vendors

dir_v := $(VEND)/$(CONFIG_VENDOR)/$(CONFIG_PRODUCT)/.

# Note: the all and clean targets are not normally used,
# since user/Makefile jumps directory to the product directory
all image clean romfs romfs.post vendor_%:
	$(MAKE) -C $(dir_v) dir_v=$(dir_v) -f $(VEND)/vendors-common.mak $@

prune:
	@for i in `ls -d */ | grep -v -e '$(CONFIG_VENDOR)' -e 'config' -e 'Generic'`; do \
		rm -fr $$i; \
	done
	@for i in `ls -d $(CONFIG_VENDOR)/* | grep -v $(CONFIG_PRODUCT)`; do \
		rm -fr $$i; \
	done

=== ap/gpl/Makefile ===
#
# Copyright 2005  Hon Hai Precision Ind. Co. Ltd.
#  All Rights Reserved.
# No portions of this material shall be reproduced in any form without the
# written permission of Hon Hai Precision Ind. Co. Ltd.
#
# All information contained in this document is Hon Hai Precision Ind.
# Co. Ltd. company private, proprietary, and trade secret property and
# are protected by international intellectual property laws and treaties.
#
# $Id$
#

include config.mk
include config.in

#
# Paths
#

SUBDIRS := 

#SUBDIRS += dnsmasq
#SUBDIRS += dnsmasq-2.15
SUBDIRS += udhcpd
#SUBDIRS += ppp/pppoecd
#SUBDIRS += ppp-2.4.4/pppd pppoecd
SUBDIRS += ntpclient
SUBDIRS += bzip2

ifeq ($(CONFIG_RIP),y)
SUBDIRS	+= zebra
endif

ifeq ($(CONFIG_PPTP),y)
#SUBDIRS	+= ppp-2.4.4/pppd pptp
# SUBDIRS	+= ppp/pppd pptp
SUBDIRS	+= pptp
endif

ifeq ($(CONFIG_L2TP),y)
SUBDIRS += l2tpd-0.69
endif

ifeq ($(CONFIG_BPA),y)
SUBDIRS	+= bpalogin
endif

ifeq ($(CONFIG_DLNA),y)
SUBDIRS += minidlna
endif

ifeq ($(AP_MODE),y)
SUBDIRS += zeroconf-0.9
endif

#water, 10/30/2008, @samba
ifeq ($(SAMBA_ENABLE_FLAG),y)
SUBDIRS	+= samba-3.0.13
SUBDIRS	+= bftpd-1.6.6
endif

# pling added 05/04/2009, for NTFS-3g
ifeq ($(CONFIG_NTFS_3G),y)
SUBDIRS += ntfs-3g-2009.3.8
endif
#pling added 05/07/2009, for mtools (to read FAT volume label)
ifeq ($(CONFIG_MTOOLS),y)
SUBDIRS += mtools-4.0.10
#	cd mtools-4.0.10 && \
#	echo "ac_cv_func_setpgrp_void=yes" > config.cache && \
#	echo "ac_cv_lib_ICE_IceConnectionNumber=no" >> config.cache && \
#	CC=$(CC) $(CONFIGURE) -C CFLAGS="$(CFLAGS)" \
#		--disable-floppyd --with-x=no --prefix=$(TARGETDIR)
endif
#Foxconn add start, stanley, 01/16/2010 @IGMP
ifeq ($(CONFIG_IGMP_PROXY),y)
SUBDIRS	+= IGMP-PROXY
endif
#Foxconn add end, stanley, 01/16/2010 @IGMP
#SUBDIRS += iproute2

ifeq ($(CONFIG_OPENSSL),y)
OPENSSL_DIR = $(GPLTOPDIR)/openssl
preobjs += openssl
else
OPENSSL_DIR = $(SRCBASE)/user/openssl-0.9.8e
#OPENSSL_DIR = $(SRCBASE)/user/openssl-1.0.2h
endif

ifeq ($(CONFIG_WGET),y)
preobjs += wget
endif

ifeq ($(CONFIG_CURL),y)
preobjs += curl
endif

ifeq ($(CONFIG_RADVD),y)
preobjs += radvd
endif

ifeq ($(CONFIG_DHCP6),y)
preobjs += dhcp6
endif

all: preobj
	for i in ${SUBDIRS}; do \
		(cd $$i && make) || exit 1; \
	done

preobj:
	for i in ${preobjs}; do \
		$(MAKE) $$i || exit 1; \
	done

preobj-install:
	for i in ${preobjs}; do \
		$(MAKE) $$i-install || exit 1; \
	done

preobj-clean:
	for i in ${preobjs}; do \
		$(MAKE) $$i-clean || exit 1; \
	done

openssl:
ifeq ($(CONFIG_OPENSSL),y)
	[ ! -d openssl ] || [ ! -f openssl/Makefile ] || $(MAKE) -C openssl
endif
	[ ! -f $(OPENSSL_DIR)/libssl.so ] || (mkdir -p $(OPENSSL_DIR)/lib && cp $(OPENSSL_DIR)/libssl.so $(OPENSSL_DIR)/lib)

openssl-install:
	[ ! -d openssl ] || [ ! -f openssl/Makefile ] || $(MAKE) -C openssl install

openssl-clean:
	[ ! -d openssl ] || [ ! -f openssl/Makefile ] || $(MAKE) -C openssl clean

wget: openssl
	[ ! -d wget-1.14 ] || ( cd wget-1.14 && CC=$(CC) $(CONFIGURE) \
		CFLAGS="$(CFLAGS) -DMB_CUR_MAX=1" LDFLAGS="$(LDFLAGS) -L$(OPENSSL_DIR)" \
		--with-ssl=openssl --with-libssl-prefix=$(OPENSSL_DIR) --prefix=$(TARGETDIR) && cd ..)
	[ ! -d wget-1.14 ] || [ ! -f wget-1.14/Makefile ] || $(MAKE) -C wget-1.14

wget-install:
	[ ! -d wget-1.14 ] || [ ! -f wget-1.14/Makefile ] || $(MAKE) -C wget-1.14 install

wget-clean:
	[ ! -d wget-1.14 ] || [ ! -f wget-1.14/Makefile ] || $(MAKE) -C wget-1.14 distclean

curl: openssl
	[ ! -d curl-7.23.1 ] || [ ! -f curl-7.23.1/Makefile ] || $(MAKE) -C curl-7.23.1 SSL_PATH=$(OPENSSL_DIR)

curl-install:
	[ ! -d curl-7.23.1 ] || [ ! -f curl-7.23.1/Makefile ] || $(MAKE) -C curl-7.23.1 install

curl-clean:
	[ ! -d curl-7.23.1 ] || [ ! -f curl-7.23.1/Makefile ] || $(MAKE) -C curl-7.23.1 distclean

radvd: flex
	[ ! -d radvd ] || [ -f radvd/Makefile ] || ( cd radvd && CC=$(CC) $(CONFIGURE) && cd .. )
	[ ! -d radvd ] || [ ! -f radvd/Makefile ] || $(MAKE) -C radvd CC=$(CC) radvd_LDADD="-L../flex -lfl"

radvd-install:
	[ ! -d radvd ] || install -D -m 755 radvd/radvd $(TARGETDIR)/usr/sbin/radvd
	[ ! -d radvd ] || $(STRIP) $(TARGETDIR)/usr/sbin/radvd

radvd-clean:
	[ ! -d radvd ] || [ ! -f radvd/Makefile ] || $(MAKE) -C radvd distclean

flex:
	[ ! -d flex ] || [ -f flex/Makefile ] || ( cd flex && CC=$(CC) $(CONFIGURE) && cd .. )
	[ ! -d flex ] || [ ! -f flex/Makefile ] || $(MAKE) -C flex CC=$(CC) RANLIB=$(RANLIB)

dhcp6: openssl
	[ ! -d dhcp6 ] || [ -f dhcp6/Makefile ] || (cd dhcp6 && \
		echo "ac_cv_func_setpgrp_void=yes" > config.cache && \
		CC=$(CC) $(CONFIGURE) -C CFLAGS="-I$(LINUXDIR)/include" \
		LDFLAGS="-L$(SRCBASE)/lib/lib -L$(OPENSSL_DIR)" && cd ..)
	[ ! -d dhcp6 ] || [ ! -f dhcp6/Makefile ] || $(MAKE) -C dhcp6 CC=$(CC)

dhcp6-install:
	[ ! -d dhcp6 ] || install -D -m 755 dhcp6/dhcp6s $(TARGETDIR)/usr/sbin/dhcp6s
	[ ! -d dhcp6 ] || $(STRIP) $(TARGETDIR)/usr/sbin/dhcp6s
	[ ! -d dhcp6 ] || install -D -m 755 dhcp6/dhcp6c $(TARGETDIR)/usr/sbin/dhcp6c
	[ ! -d dhcp6 ] || $(STRIP) $(TARGETDIR)/usr/sbin/dhcp6c

dhcp6-clean:
	[ ! -d dhcp6 ] || [ ! -f dhcp6/Makefile ] || $(MAKE) -C dhcp6 distclean

install: preobj-install
	for i in ${SUBDIRS}; do \
		(cd $$i && make install) || exit 1; \
	done

romfs: install

clean: preobj-clean
	for i in ${SUBDIRS}; do \
		(cd $$i && make clean) || exit 1; \
	done

.PHONY: all install clean romfs preobj preobj-install preobj-clean
.PHONY: openssl openssl-install openssl-clean wget wget-install wget-clean
.PHONY: radvd radvd-install radvd-clean flex dhcp6 dhcp6-install dhcp6-clean

.PHONY: $(SUBDIRS)

=== lib/e2fsprogs-1.41.3/Makefile ===
srcdir = .
top_srcdir = .

top_builddir = .
my_dir = .
INSTALL = /usr/bin/install -c

# Beginning of file MCONFIG

all::

check::

SHELL = /bin/sh

COMPRESS_EXT = gz bz2 bz Z

prefix = /usr
root_prefix = 
exec_prefix = ${prefix}
root_bindir = ${root_prefix}/bin
root_sbindir = ${root_prefix}/sbin
root_libdir = ${root_prefix}/lib
datarootdir = ${prefix}/share
bindir = ${exec_prefix}/bin
sbindir = ${exec_prefix}/sbin
libdir = ${exec_prefix}/lib
datadir= ${datarootdir}
localedir = $(datadir)/locale
root_sysconfdir= ${root_prefix}/etc
includedir = ${prefix}/include
mandir = ${datarootdir}/man
man1dir = $(mandir)/man1
man3dir = $(mandir)/man3
man5dir = $(mandir)/man5
man8dir = $(mandir)/man8
infodir = ${datarootdir}/info
datadir = ${datarootdir}



#CC = /opt/buildroot-gcc342/bin/mipsel-linux-gcc
BUILD_CC = gcc
DEFS = -DLOCALEDIR=\"$(localedir)\" -DROOT_SYSCONFDIR=\"$(root_sysconfdir)\" -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DENABLE_HTREE=1 -DCONFIG_TESTIO_DEBUG=1 -DUSE_UUIDD=1 -DPACKAGE=\"e2fsprogs\" -DVERSION=\"0.14.1\" -DHAVE_LONG_LONG=1 -DHAVE_LONG_DOUBLE=1 -DHAVE_WCHAR_T=1 -DHAVE_WINT_T=1 -DHAVE_INTTYPES_H_WITH_UINTMAX=1 -DHAVE_STDINT_H_WITH_UINTMAX=1 -DHAVE_INTMAX_T=1 -DHAVE_POSIX_PRINTF=1 -DHAVE_ALLOCA_H=1 -DHAVE_ALLOCA=1 -DHAVE_STDLIB_H=1 -DHAVE_UNISTD_H=1 -DHAVE_GETPAGESIZE=1 -DINTDIV0_RAISES_SIGFPE=0 -DHAVE_UNSIGNED_LONG_LONG=1 -DHAVE_UINTMAX_T=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STDINT_H=1 -DHAVE_LIMITS_H=1 -DHAVE_LOCALE_H=1 -DHAVE_NL_TYPES_H=1 -DHAVE_MALLOC_H=1 -DHAVE_STDDEF_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_SYS_PARAM_H=1 -DHAVE_ASPRINTF=1 -DHAVE_FWPRINTF=1 -DHAVE_GETCWD=1 -DHAVE_GETEGID=1 -DHAVE_GETEUID=1 -DHAVE_GETGID=1 -DHAVE_GETUID=1 -DHAVE_MEMPCPY=1 -DHAVE_MUNMAP=1 -DHAVE_PUTENV=1 -DHAVE_SETENV=1 -DHAVE_SETLOCALE=1 -DHAVE_SNPRINTF=1 -DHAVE_STPCPY=1 -DHAVE_STRCASECMP=1 -DHAVE_STRDUP=1 -DHAVE_STRTOUL=1 -DHAVE_TSEARCH=1 -DHAVE_WCSLEN=1 -DHAVE___FSETLOCKING=1 -DHAVE_DECL__SNPRINTF=0 -DHAVE_DECL__SNWPRINTF=0 -DHAVE_DECL_FEOF_UNLOCKED=1 -DHAVE_DECL_FGETS_UNLOCKED=0 -DHAVE_DECL_GETC_UNLOCKED=1 -DHAVE_LANGINFO_CODESET=1 -DHAVE_LC_MESSAGES=1 -DENABLE_NLS=1 -DHAVE_DIRENT_H=1 -DHAVE_ERRNO_H=1 -DHAVE_GETOPT_H=1 -DHAVE_MALLOC_H=1 -DHAVE_MNTENT_H=1 -DHAVE_PATHS_H=1 -DHAVE_SEMAPHORE_H=1 -DHAVE_SETJMP_H=1 -DHAVE_SIGNAL_H=1 -DHAVE_STDARG_H=1 -DHAVE_STDINT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_TERMIOS_H=1 -DHAVE_TERMIO_H=1 -DHAVE_UNISTD_H=1 -DHAVE_UTIME_H=1 -DHAVE_LINUX_FD_H=1 -DHAVE_LINUX_MAJOR_H=1 -DHAVE_NETINET_IN_H=1 -DHAVE_SYS_FILE_H=1 -DHAVE_SYS_IOCTL_H=1 -DHAVE_SYS_MMAN_H=1 -DHAVE_SYS_PRCTL_H=1 -DHAVE_SYS_QUEUE_H=1 -DHAVE_SYS_RESOURCE_H=1 -DHAVE_SYS_SELECT_H=1 -DHAVE_SYS_SOCKET_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_SYSCALL_H=1 -DHAVE_SYS_SYSMACROS_H=1 -DHAVE_SYS_TIME_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_UN_H=1 -DHAVE_SYS_WAIT_H=1 -DHAVE_SYS_MOUNT_H=1 -DHAVE_NET_IF_H=1 -DHAVE_VPRINTF=1 -DHAVE_RECLEN_DIRENT=1 -DHAVE_TYPE_SSIZE_T=1 -DHAVE_LSEEK64_PROTOTYPE=1 -DSIZEOF_SHORT=2 -DSIZEOF_INT=4 -DSIZEOF_LONG=4 -DSIZEOF_LONG_LONG=8 -DHAVE_INTTYPES_H=1 -DHAVE_INTPTR_T=1 -DHAVE_GETRUSAGE=1 -DHAVE_LLSEEK=1 -DHAVE_LSEEK64=1 -DHAVE_OPEN64=1 -DHAVE_FSTAT64=1 -DHAVE_FTRUNCATE64=1 -DHAVE_STRTOULL=1 -DHAVE_STRCASECMP=1 -DHAVE_SRANDOM=1 -DHAVE_JRAND48=1 -DHAVE_FCHOWN=1 -DHAVE_MALLINFO=1 -DHAVE_FDATASYNC=1 -DHAVE_STRNLEN=1 -DHAVE_STRPTIME=1 -DHAVE_STRDUP=1 -DHAVE_SYSCONF=1 -DHAVE_PATHCONF=1 -DHAVE_MEMALIGN=1 -DHAVE_VALLOC=1 -DHAVE_PRCTL=1 -DHAVE_MMAP=1 -DHAVE_UTIME=1 -DHAVE_SETRESUID=1 -DHAVE_SETRESGID=1 -DHAVE_USLEEP=1 -DHAVE_NANOSLEEP=1 -DHAVE_DLOPEN=1 -DHAVE_SEM_INIT=1 -DHAVE_EXT2_IOCTLS=1
CFLAGS = -g -O2
CPPFLAGS =  -I$(top_builddir)/lib -I$(top_srcdir)/lib 
INTL_FLAGS = -I$(top_builddir)/intl -I$(top_srcdir)/intl
ALL_CFLAGS = $(CPPFLAGS) $(DEFS) $(USE_WFLAGS) $(CFLAGS) $(XTRA_CFLAGS) \
	$(INTL_FLAGS) $(LINUX_INCLUDE) 
#LDFLAGS = 
ALL_LDFLAGS = $(LDFLAGS) 
LDFLAGS_STATIC = $(LDFLAGS) -static
BUILD_CFLAGS = 
BUILD_LDFLAGS = 
RM = /bin/rm
LN = /bin/ln
LN_S = ln -s
MV = /bin/mv
CP = /bin/cp
CHMOD = /bin/chmod
AR = ar
AWK = gawk
SED = /bin/sed
PERL = /usr/bin/perl
RANLIB = ranlib
STRIP = strip
LD = $(PURE) #/opt/buildroot-gcc342/bin/mipsel-linux-gcc
ARUPD = $(AR) r
ARGEN = $(AR) rc
LDCONFIG = /sbin/ldconfig
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}
MKINSTALLDIRS = $(top_builddir)/config/mkinstalldirs

#
# Library definitions
#
LIB = $(top_builddir)/lib
LIBSS = $(LIB)/libss.a  -ldl
LIBCOM_ERR = $(LIB)/libcom_err.a  -lpthread
LIBE2P = $(LIB)/libe2p.a
LIBEXT2FS = $(LIB)/libext2fs.a
LIBUUID = $(LIB)/libuuid.a 
LIBBLKID = $(LIB)/libblkid.a  $(LIBUUID)
LIBINTL = ${top_builddir}/intl/libintl.a 
DEPLIBSS = $(LIB)/libss.a
DEPLIBUUID = $(LIB)/libuuid.a
DEPLIBBLKID = $(LIB)/libblkid.a  $(LIBUUID)

STATIC_LIBSS = $(LIB)/libss.a -ldl
STATIC_LIBCOM_ERR = $(LIB)/libcom_err.a -lpthread
STATIC_LIBE2P = $(LIB)/libe2p.a
STATIC_LIBEXT2FS = $(LIB)/libext2fs.a
STATIC_LIBUUID = $(LIB)/libuuid.a  
STATIC_LIBBLKID = $(LIB)/libblkid.a
DEPSTATIC_LIBSS = $(LIB)/libss.a
DEPSTATIC_LIBUUID = $(LIB)/libuuid.a
DEPSTATIC_LIBBLKID = $(LIB)/libblkid.a

PROFILED_LIBSS = $(LIB)/libss -ldl
PROFILED_LIBCOM_ERR = $(LIB)/libcom_err
PROFILED_LIBE2P = $(LIB)/libe2p
PROFILED_LIBEXT2FS = $(LIB)/libext2fs
PROFILED_LIBUUID = $(LIB)/libuuid  
PROFILED_LIBBLKID = $(LIB)/libblkid
DEPPROFILED_LIBUUID = $(LIB)/libuuid
DEPPROFILED_LIBBLKID = $(LIB)/libblkid

# An include directive pointing to a directory holding enough linux-like
# include files to satisfy some programs here
LINUX_INCLUDE=

#
# A fast substitution command for fixing up man pages, shell scripts, etc.
#
SUBST_CONF=$(top_builddir)/util/subst.conf
SUBSTITUTE= $(top_builddir)/util/subst -f $(SUBST_CONF)
SUBSTITUTE_UPTIME= $(top_builddir)/util/subst -t -f $(SUBST_CONF)
DEP_SUBSTITUTE= $(top_builddir)/util/subst $(SUBST_CONF)

$(top_builddir)/util/subst:
	cd $(top_builddir)/util ; $(MAKE) subst

#
# Warning flags
#
# Run make gcc-wall to do a build with warning messages.
#
#
WFLAGS=		-std=c99 -D_XOPEN_SOURCE=600 -D_GNU_SOURCE \
			-pedantic $(WFLAGS_EXTRA) \
			-Wall -W -Wwrite-strings -Wpointer-arith \
			-Wcast-qual -Wcast-align -Wno-variadic-macros \
			-Wstrict-prototypes -Wmissing-prototypes \
			-Wformat-security  -Wformat-nonliteral \
			-Wmissing-format-attribute -O2 -Wstrict-aliasing \
			-Wnested-externs -Winline -DNO_INLINE_FUNCS -Wshadow \
			-UENABLE_NLS

gcc-wall-new:
	(make USE_WFLAGS="$(WFLAGS)" > /dev/null) 2>&1 | sed -f $(top_srcdir)/util/gcc-wall-cleanup 

gcc-wall:
	make clean > /dev/null
	make gcc-wall-new

#
# Installation user and groups
#
BINGRP=		bin
BINOWN=		bin
BINMODE=	555
INCGRP=		bin
INCOWN=		bin
INCMODE=	444
LIBOWN=		bin
LIBGRP=		bin
LIBMODE=	444
MANGRP=		bin
MANOWN=		bin
MANMODE=	444

#
# Autoconf magic...
#

DEP_LIB_MAKEFILES = $(top_srcdir)/lib/Makefile.elf-lib  \
	$(top_srcdir)/lib/Makefile.bsd-lib $(top_srcdir)/lib/Makefile.darwin-lib \
	$(top_srcdir)/lib/Makefile.solaris-lib $(top_srcdir)/lib/Makefile.checker \
	$(top_srcdir)/lib/Makefile.profile

$(top_builddir)/config.status: $(top_srcdir)/configure
	cd $(top_builddir); ./config.status --recheck

$(top_builddir)/MCONFIG: $(top_srcdir)/MCONFIG.in $(top_builddir)/config.status
	cd $(top_builddir); CONFIG_FILES=MCONFIG ./config.status

$(top_builddir)/lib/substitute_sh: $(top_srcdir)/lib/substitute_sh.in \
		$(top_builddir)/config.status
	cd $(top_builddir); CONFIG_FILES=lib/substitute_sh ./config.status

$(top_builddir)/util/subst.conf: $(top_srcdir)/util/subst.conf.in \
		$(top_builddir)/config.status
	cd $(top_builddir); CONFIG_FILES=util/subst.conf ./config.status

Makefile: $(srcdir)/Makefile.in $(top_builddir)/MCONFIG \
		$(DEP_MAKEFILE) $(top_builddir)/config.status
	cd $(top_builddir); CONFIG_FILES=$(my_dir)/Makefile ./config.status

#$(top_srcdir)/configure: $(top_srcdir)/configure.in
#	cd $(top_srcdir) && autoconf

#
# Make depend magic...
#

.depend: Makefile $(SRCS) $(top_srcdir)/depfix.sed $(top_srcdir)/wordwrap.pl
	if test -n "$(SRCS)" ; then \
		$(CC) -M $(ALL_CFLAGS) $(SRCS) | \
			$(SED) -f $(top_srcdir)/depfix.sed \
			    -e 's; $(srcdir)/; $$(srcdir)/;g' \
			    -e 's; $(top_srcdir)/; $$(top_srcdir)/;g' \
			    -e 's; $(top_builddir)/; $$(top_builddir)/;g' \
			    -e 's; \./; ;g' \
			    -e '/^#/d' \
			    -e '/^ *\\$$/d' | \
			$(PERL) $(top_srcdir)/wordwrap.pl > .depend; \
	else :; fi

depend:: .depend
	if test -n "$(SRCS)" ; then \
		sed -e '/^# +++ Dependency line eater +++/,$$d' \
			< $(srcdir)/Makefile.in | cat - .depend \
			> $(srcdir)/Makefile.in.new; \
	if cmp -s $(srcdir)/Makefile.in $(srcdir)/Makefile.in.new ; then \
		$(RM) $(srcdir)/Makefile.in.new ; \
	else \
		$(MV) $(srcdir)/Makefile.in $(srcdir)/Makefile.in.old; \
		$(MV) $(srcdir)/Makefile.in.new $(srcdir)/Makefile.in; \
	fi ; else :; fi

# End of file MCONFIG

% : %.sh

RESIZE_DIR= resize
DEBUGFS_DIR= debugfs

LIB_SUBDIRS=lib/et lib/ss lib/e2p lib/uuid lib/ext2fs lib/blkid intl
PROG_SUBDIRS=e2fsck $(DEBUGFS_DIR) misc $(RESIZE_DIR) tests/progs po
SUBDIRS=util $(LIB_SUBDIRS) $(PROG_SUBDIRS) tests

SUBS= lib/ext2fs/ext2_types.h lib/blkid/blkid_types.h lib/uuid/uuid_types.h

TAR=tar

all:: subs
	$(MAKE) libs
	$(MAKE) progs
	$(MAKE) docs

subs: $(DEP_SUBSTITUTE)
	@for i in $(SUBS) ; do if test -d `dirname $$i` ; \
		then $(MAKE) $$i || exit $$? ; fi ; done
	@(if test -d lib/et ; then cd lib/et && $(MAKE) compile_et; fi)
	@(if test -d lib/ext2fs ; then cd lib/ext2fs && $(MAKE) ext2_err.h; fi)

progs: subs all-progs-recursive
libs: subs all-libs-recursive

e2fsprogs.spec: $(DEP_SUBSTITUTE) e2fsprogs.spec.in
	cd $(top_builddir); CONFIG_FILES=./e2fsprogs.spec ./config.status

rpm: e2fsprogs.spec
	sh contrib/build-rpm

docs:
	-@test -d doc && cd doc && $(MAKE) libext2fs.info

install-doc-libs:
	-@test -d doc && cd doc && $(MAKE) install-doc-libs

uninstall-doc-libs:
	-@test -d doc && cd doc && $(MAKE) uninstall-doc-libs

clean-doc:
	-@test -d doc && cd doc && $(MAKE) clean

distclean-doc:
	-test -d doc && cd doc && $(MAKE) distclean

install: subs all-libs-recursive install-progs-recursive \
  install-shlibs-libs-recursive install-doc-libs
	if test ! -d e2fsck && test ! -d debugfs && test ! -d misc && test ! -d ext2ed ; then $(MAKE) install-libs ; fi

install-strip: subs all-libs-recursive install-strip-progs-recursive \
  install-shlibs-strip-libs-recursive install-doc-libs

uninstall: uninstall-progs-recursive uninstall-shlibs-libs-recursive uninstall-doc-libs

install-libs: install-libs-recursive

uninstall-libs: uninstall-libs-recursive

TAGS clean-recursive distclean-recursive depend-recursive check-recursive \
  mostlyclean-recursive realclean-recursive:
	@for subdir in $(SUBDIRS); do \
	  if test -d $$subdir ; then \
	    target=`echo $@|$(SED) 's/-recursive//'`; \
	    echo making $$target in $$subdir; \
	    (cd $$subdir && $(MAKE) $$target) || exit 1; \
	  fi ; \
	done

all-progs-recursive install-progs-recursive install-strip-progs-recursive \
  uninstall-progs-recursive: all-libs-recursive
	@for subdir in $(PROG_SUBDIRS); do \
	  if test -d $$subdir ; then \
	    target=`echo $@|$(SED) 's/-progs-recursive//'`; \
	    echo making $$target in $$subdir; \
	    (cd $$subdir && $(MAKE) $$target) || exit 1; \
	  fi ; \
	done

all-libs-recursive install-libs-recursive install-strip-libs-recursive \
  uninstall-libs-recursive install-shlibs-libs-recursive \
  install-shlibs-strip-libs-recursive uninstall-shlibs-libs-recursive:
	@for subdir in $(LIB_SUBDIRS); do \
	  if test -d $$subdir ; then \
	    target=`echo $@|$(SED) 's/-libs-recursive//'`; \
	    echo making $$target in $$subdir; \
	    (cd $$subdir && $(MAKE) $$target) || exit 1; \
	  fi ; \
	done

mostlyclean: mostlyclean-recursive mostlyclean-local

clean: clean-recursive clean-local clean-doc
	$(RM) -f $(SUBS)

=== lib/libbluetooth/Makefile ===
TOPDIR=../
include $(TOPDIR)Rules.mak

CFLAGS+=$(SSP_ALL_CFLAGS) -DHAVE_CONFIG_H -Iinclude/

LIBBLUETOOTH=libbluetooth.a
LIBBLUETOOTH_VERS=3.1.0
LIBBLUETOOTH_SHARED=libbluetooth.so.$(LIBBLUETOOTH_VERS)

OBJS    := bluetooth.o  hci.o  sdp.o

all: sym_link $(LIBBLUETOOTH)

sym_link:
	$(LN) -sf ../include include/bluetooth

$(OBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

shared: all
	$(LD) $(LDFLAGS) -soname=$(LIBBLUETOOTH_SHARED) \
		-o $(LIBBLUETOOTH_SHARED) --whole-archive $(LIBBLUETOOTH) \
		--no-whole-archive \
		-L$(TOPDIR)lib -lc $(LDADD_LIBFLOAT) $(LIBGCC);
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBBLUETOOTH_SHARED)
	$(INSTALL) -m 644 $(LIBBLUETOOTH_SHARED) $(TOPDIR)lib


$(LIBBLUETOOTH) ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBBLUETOOTH) $(OBJS)
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBBLUETOOTH)
	$(INSTALL) -m 644 $(LIBBLUETOOTH) $(TOPDIR)lib

romfs:
	$(INSTALL) -m 644 $(LIBBLUETOOTH_SHARED) $(TOPDIR)lib

$(OBJS): Makefile

clean:
	$(RM) *.[oa] $(LIBBLUETOOTH_SHARED)*

=== lib/libc/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

#--------------------------------------------------------
#
#There are a number of configurable options in "Config"
#
#--------------------------------------------------------

# MTK/Ralink, export 'READY_FOR_MIPS16' varaible to let Rules.mak know
# to use mips16 cflags.
READY_FOR_MIPS16=y
export READY_FOR_MIPS16

TOPDIR=../
include $(TOPDIR)Rules.mak

DIRS = misc pwd_grp stdio string termios inet signal stdlib sysdeps unistd

# Check if the target architecture has a version script for
# libc, and if so, include it when linking.
VERSION_SCRIPT:=${shell if [ -f sysdeps/linux/$(TARGET_ARCH)/libc.map ] ; then \
        echo "--version-script sysdeps/linux/$(TARGET_ARCH)/libc.map"; fi}

LIBNAME_TARGET:=$(TOPDIR)lib/$(LIBNAME)

all: halfclean $(LIBNAME_TARGET) $(DO_SHARED)

# Some functions are duplicated across subdirs, and when you pass $(AR)
# the same object file more than once, it'll add it to the archive multiple 
# times (boo!).  So what we do here is:
#  - import all the objects (thus we may have dupes)
#  - delete all the dupes
#  - re-import certain objects based upon preference
#    - the sysdeps dir should override all other symbols for example
# We need to use shell globbing with obj.* because if we use make's wildcard,
# the wildcard will be evaluated when `make` is run instead of when the make 
# target is evaluated.  That means if you run `rm obj.* ; make`, the wildcard 
# will evaluate to no files :(.
$(LIBNAME) shared_$(LIBNAME) ar-target: subdirs
	$(RM) $(LIBNAME) shared_$(LIBNAME)
	objs=`cat obj.*` ; \
	$(AR) $(ARFLAGS) $(LIBNAME) $$objs && \
	$(AR) dN 2 $(LIBNAME) $$objs && \
	$(AR) dN 2 $(LIBNAME) $$objs
	@for objfile in obj.signal \
	                obj.string.generic obj.string.$(TARGET_ARCH) obj.string \
	                obj.sysdeps.common obj.sysdeps.$(TARGET_ARCH) ; do \
		if [ -e $$objfile ] ; then \
			if [ "$(MAKE_IS_SILENT)" = "n" ] ; then \
				echo $(AR) $(ARFLAGS) $(LIBNAME) $$objfile ; \
			fi ; \
			objs=`cat $$objfile` ; \
		fi ; \
		$(AR) $(ARFLAGS) $(LIBNAME) $$objs || exit 1 ; \
	done
	cp $(LIBNAME) shared_$(LIBNAME)
	$(AR) $(ARFLAGS) $(LIBNAME) misc/internals/static.o
	$(RANLIB) $(LIBNAME)

$(LIBNAME_TARGET): $(LIBNAME)
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBNAME)
	$(INSTALL) -m 644 $(LIBNAME) $(TOPDIR)lib

shared: shared_$(LIBNAME)
	$(LD) $(LDFLAGS) $(VERSION_SCRIPT) -soname=$(SHARED_MAJORNAME) -o $(SHARED_FULLNAME) \
		--whole-archive shared_$(LIBNAME) \
		$(TOPDIR)libc/misc/internals/interp.o --no-whole-archive \
		-init __uClibc_init $(TOPDIR)lib/$(UCLIBC_LDSO) $(LIBGCC) $(LDADD_LIBFLOAT)
	@true #$(RM) -r tmp
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(SHARED_FULLNAME)
	$(INSTALL) -m 644 $(SHARED_FULLNAME) $(TOPDIR)lib
	$(LN) -sf $(SHARED_FULLNAME) $(TOPDIR)lib/libc.so
	$(LN) -sf $(SHARED_FULLNAME) $(TOPDIR)lib/$(SHARED_MAJORNAME)

halfclean:
	@$(RM) $(LIBNAME) shared_$(LIBNAME) uClibc_config.h
	@$(RM) $(SHARED_FULLNAME) $(SHARED_MAJORNAME) uClibc-0.* libc.so*

tags:
	ctags -R

clean: subdirs_clean halfclean
	@$(RM) -r tmp
	$(RM) include/asm include/linux include/bits
	$(RM) obj.*

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(DIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

.PHONY: dummy subdirs

=== user/ecmh/debian/control ===
Source: ecmh
Section: net
Priority: optional
Maintainer: Jeroen Massar <jeroen@unfix.org>
Build-Depends: debhelper (>> 3.0.0)
Standards-Version: 3.5.2

Package: ecmh
Architecture: any
Depends: ${shlibs:Depends}
Recommends: radvd
Description: Multicast Routing Daemon
 Easy Cast du Multi Hub (ecmh) is a networking daemon that relays and
 aggregates multicast packets from/to network interfaces.
 .
 Currently it supports IPv6 Multicast using MLDv1 and MLDv2 including
 Source Specific Multicast (SSM).
 .
 It is used by SixXS (http://www.sixxs.net) to enable the users to
 send and receive Multicast IPv6 over IPv6 tunnels provided by SixXS.
 .
 Website: http://unfix.org/projects/ecmh/

=== user/ecmh/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
# Adjusted by Jeroen Massar <jeroen@unfix.org> for ecmh

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

configure: configure-stamp
configure-stamp:
	dh_testdir

	touch configure-stamp

build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch build-stamp

clean:
	dh_testdir
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) distclean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/ecmh.
	$(MAKE) DESTDIR=`pwd`/debian/ecmh install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
	dh_installinit
	dh_installcron
	dh_installman
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== user/openl2tp-1.6/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	OPT_CFLAGS = -O0
else
	OPT_CFLAGS = -O2
endif

export OPT_CFLAGS

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	dpatch apply-all

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) PPPD_VERSION=2.4.4 KERNEL_SRCDIR=/usr/src/linux-headers-`uname -r`
	#docbook-to-man debian/openl2tp.sgml > openl2tp.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) clean

	dh_clean  --exclude ./debian.orig

install: build
	dh_testdir
	dh_testroot
	dh_clean -k  --exclude ./debian.orig
	dh_installdirs

	# Add here commands to install the package into debian/openl2tp.
	$(MAKE) PPPD_VERSION=2.4.4 \
		KERNEL_SRCDIR=/usr/src/linux-headers-`uname -r` \
		DESTDIR=$(CURDIR)/debian/openl2tp install

	# Move some files to openl2tp-dev
	-mkdir -p $(CURDIR)/debian/openl2tp-dev/usr/lib/openl2tp
	mv -f $(CURDIR)/debian/openl2tp/usr/lib/openl2tp/*.[hx] $(CURDIR)/debian/openl2tp-dev/usr/lib/openl2tp/ 


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== user/openswan-2.6.22/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

export DH_OPTIONS

ifeq (,$(wildcard /usr/bin/po2debconf))
	PO2DEBCONF := no
	MINDEBCONFVER := 0.5
else
	PO2DEBCONF := yes
	MINDEBCONFVER := 1.2.0
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp

patch-stamp:
	dh_testdir

	touch patch-stamp

unpatch: 
	rm -f patch-stamp

build: build-stamp
build-stamp: patch-stamp
	# create a dummy ipsec.secrets file before building the package so
	# that no RSA keys are created during the build process
	# (a package should not include a RSA key, it should produce the key
	# on demand, e.g. in the postinst script)
	touch $(CURDIR)/debian/ipsec.secrets
	$(MAKE) programs INC_USRLOCAL=/usr \
        		 FINALBINDIR=/usr/lib/ipsec \
			 FINALLIBEXECDIR=/usr/lib/ipsec \
			 PUBDIR=/usr/sbin \
			 MANTREE=/usr/share/man \
			 CONFDIR=$(CURDIR)/debian
	# remove the temporary file, it will be created during install
	rm -f $(CURDIR)/debian/ipsec.secrets

	# here we re-generate the upstream HTML documentation
	$(MAKE) -C doc/ index.html
	
	# also generate the fswcert tool
	$(MAKE) -C programs/fswcert/
	# ugly hack....
	$(MAKE) -C programs/fswcert/ programs WERROR='-lcrypto'

	touch build-stamp

clean: unpatch
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	-$(MAKE) clean
	-$(MAKE) -C programs/fswcert/ clean
	# after a make clean, no binaries _should_ be left, but ....
	-find $(CURDIR) -name "*.o" | xargs --no-run-if-empty rm
	-find $(CURDIR)/lib/libcrypto -name "*.a" | xargs --no-run-if-empty rm

	-$(MAKE) -f debian/rules unpatch
	
	rm -rf debian/openswan-modules-source-build/

	# just in case something went wrong
	rm -f $(CURDIR)/debian/ipsec.secrets

	dh_clean

ifeq ($(PO2DEBCONF),yes)       
	# Hack for woody compatibility. This makes sure that the       
	# debian/templates file shipped in the source package doesn't 
	# specify encodings, which woody's debconf can't handle. If building
	# on a system with po-debconf installed (conveniently debhelper (>=
	# 4.1.16) depends on it), the binary-arch target will generate a
	# better version for sarge.       
	echo 1 > debian/po/output
	po2debconf debian/openswan.templates.master > debian/openswan.templates
	rm -f debian/po/output
endif

install-openswan: DH_OPTIONS=-a
install-openswan: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install INC_USRLOCAL=/usr \
        		FINALBINDIR=/usr/lib/ipsec \
			FINALLIBEXECDIR=/usr/lib/ipsec \
			PUBDIR=$(CURDIR)/debian/openswan/usr/sbin \
			MANTREE=$(CURDIR)/debian/openswan/usr/share/man \
			DESTDIR=$(CURDIR)/debian/openswan \
			USE_LDAP=true USE_LIBCURL=true HAVE_THREADS=true \
			USE_XAUTHPAM=true
	rm -rf $(CURDIR)/debian/openswan/usr/local
	install --mode=0600 $(CURDIR)/debian/ipsec.secrets.proto $(CURDIR)/debian/openswan/etc/ipsec.secrets

	# use bash for init.d and _plutorun
	patch $(CURDIR)/debian/openswan/etc/init.d/ipsec < debian/use-bash.diff
	patch $(CURDIR)/debian/openswan/usr/lib/ipsec/_plutorun < debian/use-bash.diff

	# install the fswcert tool
	install $(CURDIR)/programs/fswcert/fswcert $(CURDIR)/debian/openswan/usr/bin
	install $(CURDIR)/programs/fswcert/fswcert.8 $(CURDIR)/debian/openswan/usr/share/man/man8

	rm -f $(CURDIR)/debian/openswan/etc/init.d/ipsec?*
	rm -f $(CURDIR)/debian/openswan/usr/lib/ipsec/_plutorun?*

	# this is handled by update-rc.d
	rm -rf $(CURDIR)/debian/openswan/etc/rc?.d
        
	dh_installdocs -popenswan -n
	# change the paths in the installed doc files (but only in regular 
	# files, not in links to the outside of the build tree !)
	( cd $(CURDIR)/debian/openswan/; \
	  for f in `grep "/usr/local/" --recursive --files-with-match *`; \
	  do \
		if [ -f $$f -a ! -L $$f ]; then \
		    cp $$f $$f.old; \
 		    sed 's/\/usr\/local\//\/usr\//' $$f.old > $$f; \
		    rm $$f.old; \
		fi; \
	  done )
	# but remove the doc/src dir, which just duplicates the HTML files
	rm -rf $(CURDIR)/debian/openswan/usr/share/doc/openswan/doc/src
	  
	# the logcheck ignore files
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.paranoid $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.paranoid/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.server $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.server/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.server $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.workstation/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.violations.ignore $(CURDIR)/debian/openswan/etc/logcheck/violations.ignore.d/openswan

	# set permissions on ipsec.secrets
	chmod 600 $(CURDIR)/debian/openswan/etc/ipsec.secrets
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.conf
	chmod 700 -R $(CURDIR)/debian/openswan/etc/ipsec.d/private/
	# don't know why they come with +x set by default...
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.d/policies/*
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.d/examples/*

	# more lintian cleanups
	find $(CURDIR)/debian/openswan -name ".cvsignore" | xargs --no-run-if-empty rm -f
	find $(CURDIR)/debian/openswan -name "/.svn/" | xargs --no-run-if-empty rm -rf

install-openswan-modules-source: DH_OPTIONS=-i
install-openswan-modules-source: PKGDIR=$(CURDIR)/debian/openswan-modules-source
install-openswan-modules-source: BUILDDIR=$(CURDIR)/debian/openswan-modules-source-build
install-openswan-modules-source: patch-stamp
	dh_testdir
	dh_testroot
	dh_installdirs
	mkdir -p "$(BUILDDIR)/modules/openswan"
	mkdir -p "$(BUILDDIR)/modules/openswan/lib"
	mkdir -p "$(BUILDDIR)/modules/openswan/debian"
	mkdir -p "$(BUILDDIR)/modules/openswan/packaging"
	cp -r Makefile Makefile.top Makefile.inc Makefile.ver linux/ \
		"$(BUILDDIR)/modules/openswan"
	cp -r lib/libcrypto "$(BUILDDIR)/modules/openswan/lib/"
	cp -r packaging/makefiles packaging/linus packaging/utils packaging/defaults \
		"$(BUILDDIR)/modules/openswan/packaging/"
	find "$(BUILDDIR)/modules/openswan/lib/" -name "*.o" | xargs --no-run-if-empty rm
	install --mode=644 debian/openswan-modules-source.kernel-config "$(BUILDDIR)/modules/openswan/config-all.h"
	install --mode=755 debian/openswan-modules-source.rules "$(BUILDDIR)/modules/openswan/debian/rules"
	install --mode=644 debian/openswan-modules-source.control.in "$(BUILDDIR)/modules/openswan/debian/control.in"
	install --mode=644 debian/changelog "$(BUILDDIR)/modules/openswan/debian/"

	# This creates the NAT-T patches that can be used on the kernel tree 
	# even with openswan-modules-source.
	make nattpatch2.4 > $(BUILDDIR)/modules/openswan/debian/nat-t-2.4.diff
	make nattpatch2.6 > $(BUILDDIR)/modules/openswan/debian/nat-t-2.6.diff
        
	tar -C $(BUILDDIR) -c modules/ | gzip -9 > \
        	"$(PKGDIR)/usr/src/openswan-modules.tar.gz"
		
	dh_installdocs -popenswan-modules-source -n

	# more lintian cleanups
	find $(CURDIR)/debian/openswan-modules-source -name ".cvsignore" | xargs --no-run-if-empty rm -f
	find $(PKGDIR) -name "/.svn/" | xargs --no-run-if-empty rm -rf

install-kernel-patch-openswan: DH_OPTIONS=-i
install-kernel-patch-openswan: PKGDIR=$(CURDIR)/debian/kernel-patch-openswan
install-kernel-patch-openswan: patch-stamp
	dh_testdir
	dh_testroot
	dh_installdirs
	# some of this has been taken from Tommi Virtanen's package
	install --mode=0755 debian/kernel-patch-openswan.apply \
		"$(PKGDIR)/usr/src/kernel-patches/all/apply/openswan"
	install --mode=0755 debian/kernel-patch-openswan.unpatch \
		"$(PKGDIR)/usr/src/kernel-patches/all/unpatch/openswan"
	install --mode=0755 packaging/utils/patcher \
		"$(PKGDIR)/usr/src/kernel-patches/all/openswan"
	cp -r Makefile Makefile.inc Makefile.ver Makefile.top lib/ linux/ \
		packaging/ nat-t/ \
		"$(PKGDIR)/usr/src/kernel-patches/all/openswan"
